import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import win32frame.Panel;
import win32frame.ScrollPanel ;
import win32frame.CheckBox;
import win32frame.RadioButton;
import win32frame.PushButton;
import win32frame.StaticControl;
import win32frame.WindowMenu;
import win32frame.StatusBar;
import win32frame.ToolTip;
import win32frame.ComboBox;
import win32frame.Split;
import win32frame.Launcher;
import util.Image;
import util.BitMap ;
import std.stdio;
import std.string;
import std.utf;
import core.exception;

import FontMan;
import OpenGLFrameTest;
import GraphicFrameTest;
import SliderBase ;
import SliderGrad ;
import MyButton ;
import Spin;
import ProgressWindow;

enum CMD{
  NONE   = 0x0ff,
  MYBTN  = 0x100,
  PROGRES= 0x101,
  GDISP  = 0x102,
  SLIDE  = 0x103,
  SLIDEG = 0x104,
  SPIN   = 0x105,
  GLOBJ0 = 0x200,
  GLOBJ1 = 0x201,
  GLOBJ2 = 0x202,
  GLOBJ3 = 0x203,
  GLOBJ4 = 0x204
} ;

class SubPanel2 : WindowObject {
  Split         split1   ;
  Split         split2   ;
  ScrollPanel   panel    ;
  PushButton    button1  ;
  PushButton    button2  ;
  SliderBase    slider   ;
  SliderGrad    sliderG  ;
  Spin          spin     ;
  MyButton      mybutton ;
  ToolTip       tooltip  ;
  OpenGLFrameTest  opengl  ;
  GraphicFrameTest graphic ;
  MyButton[]    imgbtn_list;
  Launcher      launcher1,launcher2;
  StaticControl bottom ;
  HFONT         hfont_v12,hfont_f12;

  int showStrctl=0 ;

  this(string name, string ClassName) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = null ;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    //    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name) ;
    this.registwinc() ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont_v12);
      DeleteObject(hfont_f12);
      break ;

    case WM_CREATE:
      FontMan font_v12 ; font_v12.init(-12,VARIABLE_PITCH) ;
      FontMan font_f12 ; font_f12.init(-12,FIXED_PITCH) ;

      hfont_v12 = font_v12.createHFONT() ;
      hfont_f12 = font_f12.createHFONT() ;

      split1 = new Split("Split1",1) ;
      split1.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ; //| WS_THICKFRAME ) ;
      split1.setPosition(300,128,256,256) ;
      split1.setSashPos(112,50,150) ;
      addObject( split1, cast(HMENU)(CMD.NONE),true, true) ;

      panel = new ScrollPanel("Panel1") ;
      panel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      panel.setPosition(0,0,300,200) ;
      panel.setScrollWindow(0,0,400,200) ;
      panel.setEnableScroll(false,true) ;
      split1.addObject( panel, cast(HMENU)(CMD.NONE) ) ;

      bottom= new StaticControl("bottom of panel") ;
      bottom.addExStyle(WS_EX_CLIENTEDGE) ;
      bottom.addStyle(SS_CENTER) ;
      bottom.setPosition(0,180,400,20) ;
      panel.addObject(bottom, null,true,false) ;
      bottom.setFont(hfont_v12) ;

      button1= new PushButton("Progress") ;
      button1.setPosition(0,0,100,20) ;
      panel.addObject(button1, cast(HMENU)(CMD.PROGRES)) ;
      button1.setFont(hfont_v12) ;

      button2= new PushButton("HIDE") ;
      button2.setPosition(100,0,100,20) ;
      panel.addObject(button2, cast(HMENU)(CMD.GDISP)) ;
      button2.setFont(hfont_v12) ;

      mybutton = new MyButton("MyButton") ;
      mybutton.setPosition(200,0,100,20) ;
      panel.addObject(mybutton, cast(HMENU)(CMD.MYBTN), false, false) ;
      mybutton.setFont(hfont_v12) ;
      tooltip=new ToolTip() ;
      tooltip.addStyle(TTS_BALLOON) ;
      tooltip.setText("自作ボタン") ;
      mybutton.addToolTip( tooltip ) ;

      launcher1 = new Launcher("Launcher1") ;
      launcher1.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      launcher1.setPosition(0,20,300,20) ;
      int[] xlist = [16,32] ;
      int[] ylist = [16];
      launcher1.initGrid(xlist,ylist,true) ;
      panel.addObject(launcher1, cast(HMENU)(CMD.NONE), true, false) ;

      slider = new SliderBase("Slider","SliderTest") ;
      slider.addExStyle(WS_EX_CLIENTEDGE) ;
      slider.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      slider.setPosition(0,20,256,20) ;
      slider.setInfo(0, 180.0, 0.0,360.0) ;
      slider.setBGcolor(0,0,255,0) ;
      slider.setFGcolor(255,0,0,0) ;
      launcher1.addObject(slider, cast(HMENU)(CMD.SLIDE), true, false) ;
      tooltip=new ToolTip() ;
      tooltip.setText("Slider") ;
      slider.addToolTip( tooltip ) ;

      sliderG = new SliderGrad("Sliderg","SliderTestG") ;
      sliderG.addExStyle(WS_EX_CLIENTEDGE) ;
      sliderG.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      sliderG.setPosition(0,40,256,20) ;
      sliderG.setInfo(0, 50.0, 0.0,100.0) ;
      sliderG.setBGcolor(0,255,0,255) ;
      sliderG.setFGcolor(0,255,0,0) ;
      launcher1.addObject(sliderG, cast(HMENU)(CMD.SLIDEG), true, false) ;

      spin = new Spin("Spin", "Spin") ;
      spin.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      spin.setPosition(0,40,300,20) ;
      spin.setTextFormat("%.3f") ;
      spin.setInfo( 100, 1, 1600, 0.1 ) ;
      spin.setLabel("表示倍率:",60) ;
      panel.addObject(spin, cast(HMENU)(CMD.SPIN), true, false) ;
      spin.setTextFont(hfont_f12) ;
      spin.setLabelFont(hfont_f12) ;
      spin.setLabelLeftAlign() ;
      tooltip=new ToolTip() ;
      tooltip.setText("画像の表示倍率") ;
      spin.addToolTip( tooltip ) ;

      launcher2 = new Launcher("Launcher2") ;
      launcher2.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      launcher2.setPosition(0,60,300,52) ;
      launcher2.initGrid(5,1,32,32,true) ;
      panel.addObject(launcher2, cast(HMENU)(CMD.NONE), true, false) ;

      imgbtn_list.length=5 ;
      foreach( i, ref imgbtn ; imgbtn_list ){
        auto bmp = new BitMap() ;
        bmp.readImage(getHInstance(), toUTFz!(wchar*)(format("TOOLBTN%d",i)), MAKEINTRESOURCE_T!(256)) ;
        imgbtn = new MyButton(format("imgbtn%d",i)) ;
        imgbtn.addStyle(BS_CENTER|BS_VCENTER) ;
        imgbtn.setPosition(0,0,32,32) ;
        imgbtn.setBitMap(bmp) ;
        imgbtn.setFlatMode(true) ;
        launcher2.addObject(imgbtn, cast(HMENU)(CMD.GLOBJ0+i)) ;
        imgbtn.setFont(hfont_v12) ;
      }
      imgbtn_list[0].setSelectState(true) ;

      split2 = new Split("Split2") ;
      split2.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      split2.setPosition(500,100,256,256) ;
      split1.addObject(split2, cast(HMENU)(CMD.NONE)) ;

      graphic = new GraphicFrameTest("GraphicFrame", "GraphicFrameTest") ;
      graphic.setPosition(0, 460,256,256) ;
      graphic.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      graphic.setCentering(true) ;
      graphic.setAutoFocus(true) ;
      split2.addObject(graphic, cast(HMENU)(CMD.NONE)) ;
      graphic.setScaleSpin(spin) ;
      tooltip=new ToolTip() ;
      tooltip.setText("Cntl+MouseWheel:ZoomInOut") ;
      graphic.addToolTip( tooltip ) ;

      opengl = new OpenGLFrameTest("OpenGLFrame", "OpenGLFrameTest") ;
      opengl.setPosition(0,0,640,480) ;
      opengl.setStyle(WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
      split2.addObject(opengl, cast(HMENU)(CMD.NONE)) ;
      break ;

    case WM_PAINT:
      PAINTSTRUCT ps;
      HDC hdc;
      hdc = BeginPaint(hwnd, &ps);
      EndPaint(hwnd, &ps);
      break ;

    case WM_COMMAND:
      switch( LOWORD(wp) ){
      case CMD.PROGRES:
        RECT wrect ;
        GetWindowRect(hwnd,&wrect) ;
        ProgressWindow progresswin ;
        progresswin = new ProgressWindow("ProgressWindow") ;
        progresswin.start(wrect.left,wrect.top+100,400,100) ;
        for( int i=0 ; i<100 ; i++ ){
          for( int j=0 ; j<50000000 ; j++ ){
            if( j==0 ) progresswin.setRate(i+1) ;
          }
        }
        progresswin.close() ;
        SetFocus(null) ;
        break ;

      case CMD.GDISP:
        if( showStrctl==0 ){
          split2.hide() ;
          button2.setWindowText("SHOW") ;
          printStatusbar("消された") ;
        }else{
          split2.show() ;
          button2.setWindowText("HIDE") ;
          printStatusbar("表示された") ;
        }
        showStrctl = (showStrctl + 1) % 2 ;
        break ;

      case CMD.MYBTN:
        mybutton.setSelectState( mybutton.getSelectState()==true ? false : true ) ;
        break ;

      case CMD.SLIDE :
        printStatusbar(format("Slider=%d",cast(int)(slider.getValue()))) ;
        break ;

      case CMD.SLIDEG :
        printStatusbar(format("GradSlider=%d",cast(int)(sliderG.getValue()))) ;
        break ;

      case CMD.SPIN :
        graphic.setScale(spin.getValue()/100.0) ;
        graphic.reDisplay() ;
        break ;

      case CMD.GLOBJ0 :
      case CMD.GLOBJ1 :
      case CMD.GLOBJ2 :
      case CMD.GLOBJ3 :
      case CMD.GLOBJ4 :
        opengl.changeOBJ( LOWORD(wp) & 0xff ) ;
        foreach( i, imgbtn ; imgbtn_list ){
          imgbtn.setSelectState(false) ;
        }
        imgbtn_list[(LOWORD(wp) & 0xff)].setSelectState(true) ;
        break ;
      default :        break ;
      }
      break;

    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

  int LoadImage(string fname){
    int   ret=-1 ;
    Image image = new Image() ;

    try{
      if( image.open(fname)<0 ){
        ret=-1 ;
      }else{
        if( graphic !is null ){
          graphic.setImageSize(image.getWidth(),image.getHeight()) ;
          uint[][] imgbuf=graphic.getImageBuffer() ;
          if( imgbuf==null ){
            ret=-2 ;
          }else{
            int imgw=image.getWidth()  ;
            int imgh=image.getHeight() ;
            for( size_t i=0 ; i<imgh ; i++ ){
              uint[] img = image.readline(1,true) ;
              imgbuf[i][] = img[0..$] ;
              delete img ;
            }
            graphic.reDisplay() ;
            ret=0 ;
          }
        }
      }
    }catch( Exception e ){
      graphic.setImageSize(0,0) ;
      ret=-3 ;
    }catch( OutOfMemoryError e ){
      graphic.setImageSize(0,0) ;
      ret=-3 ;
    }
    image.close() ;
    clear(image) ;
    return(ret) ;
  }
}
