import win32.windows;
import win32.windef;
import win32frame.Win32Frame;
import win32frame.MsgBox;
import win32frame.glut;
import myMainWindow;
import std.stdio;
import std.string;
import core.exception;

int main(string[] args)
{
  int    argc = 1 ;
  char** argv = cast(char**)(new char*[argc]) ;
  argv[0] = args[0].dup.ptr ;

  glutInit(&argc,argv) ;

  Win32Frame win32 = new Win32Frame() ;
  string windowtitle = "Win32Frame test with D/WinAPI" ;
  version(Win64){
    windowtitle ~= "(Win64)" ;
  }else{
    windowtitle ~= "(Win32)" ;
  }
  myMainWindow frame = new myMainWindow(windowtitle,"w32ftest") ;

  try{
    frame.withRebar() ;
    win32.setMainWindow(frame) ;
    win32.setWindowPosition(CW_USEDEFAULT,CW_USEDEFAULT,640,480) ;
    win32.setWindowStyle(WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_OVERLAPPEDWINDOW | WS_VISIBLE) ;

    win32.start() ;
  }catch(Exception e){
    auto msgbox = new MsgBox(null, e.msg, "Internal Error", MB_OK ) ;
    msgbox.create() ;
  }catch(Error e){
    string msg = e.msg == "" ? "SystemError" : format("SystemError (%s@%s:%d)",e.msg,e.file,e.line) ;
    auto msgbox = new MsgBox(null, msg, "System Error", MB_OK ) ;
    msgbox.create() ;
  }

  return(0) ;
}
